var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var fieldValuesGroupStats_exports = {};
__export(fieldValuesGroupStats_exports, {
  default: () => fieldValuesGroupStats_default,
  getResults: () => getResults,
  getTotal: () => getTotal
});
module.exports = __toCommonJS(fieldValuesGroupStats_exports);
var import_utils = require("../utils.js");
async function getTotal(runSearch, { groupField: statsField }) {
  const node = {
    type: "stats",
    statsField,
    stats: { cardinality: true }
  };
  return (await runSearch(node)).context?.cardinality ?? 0;
}
async function getResults(runSearch, { groupField, statsField, includeFields }) {
  const node = {
    type: "fieldValuesGroupStats",
    groupField,
    statsField,
    size: await getTotal(runSearch, { groupField }),
    stats: includeFields ? { sum: true, topHits: { size: 1, _source: includeFields } } : { sum: true }
  };
  return ((await runSearch(node)).context?.results ?? []).map((result) => ({
    count: result.count,
    [groupField]: result.key,
    sum: result.sum,
    ...includeFields ? result.topHits.hits[0]?._source ?? {} : {}
  }));
}
var fieldValuesGroupStats_default = (service, tree, props) => {
  const runSearch = (node) => (0, import_utils.runWith)(service, tree, node);
  return {
    getTotalRecords() {
      return getTotal(runSearch, props);
    },
    async *[Symbol.asyncIterator]() {
      yield* await getResults(runSearch, props);
    }
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getResults,
  getTotal
});
